
;file save dialog test program - dedndave - 3-2011

;#################################################################################################

        .XCREF
        .NOLIST
        INCLUDE \masm32\include\masm32rt.inc
        .LIST

;#################################################################################################

WndProc     PROTO :HWND,:UINT,:WPARAM,:LPARAM

;*************************************************************************************************

IDM_FILE_SAVEAS    EQU 1101

;#################################################################################################

        .DATA

WndClass         db 'FSaveDlgTest',0
AppName          db 'File Save Dialog Test',0
szFileMenu       db 'File',0
szSaveAs         db 'Save As...',0
FileTypeStrs     db 'Text Files',0,'*.txt',0,'All Files',0,'*.*',0,0
FileExt          db 'txt',0

;*************************************************************************************************

        .DATA?

hInstance        dd ?
hWin             dd ?

wc               WNDCLASSEX <>
msg              MSG <>

ofn              OPENFILENAME <>
; lStructSize       dd ?
; hwndOwner         dd ?
; hInstance         dd ?
; lpstrFilter       dd ?
; lpstrCustomFilter dd ?
; nMaxCustFilter    dd ?
; nFilterIndex      dd ?
; lpstrFile         dd ?
; nMaxFile          dd ?
; lpstrFileTitle    dd ?
; nMaxFileTitle     dd ?
; lpstrInitialDir   dd ?
; lpstrTitle        dd ?
; Flags             dd ?
; nFileOffset       dw ?
; nFileExtension    dw ?
; lpstrDefExt       dd ?
; lCustData         dd ?
; lpfnHook          dd ?
; lpTemplateName    dd ?

FileName         db 260 dup(?)

;#################################################################################################

        .CODE

_main   PROC

;--------------------------

;init

        xor     edi,edi
        INVOKE  InitCommonControls
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        xchg    eax,esi

;--------------------------

;create menu

        INVOKE  CreatePopupMenu
        xchg    eax,ebx
        INVOKE  AppendMenu,ebx,MF_STRING,IDM_FILE_SAVEAS,offset szSaveAs
        INVOKE  CreateMenu
        xchg    eax,ebx
        INVOKE  AppendMenu,ebx,MF_POPUP,eax,offset szFileMenu

;--------------------------

;register class

        mov     wc.cbSize,sizeof WNDCLASSEX
        mov     wc.style,edi
        mov     wc.lpfnWndProc,WndProc
        mov     wc.cbClsExtra,edi
        mov     wc.cbWndExtra,edi
        mov     wc.hInstance,esi
        INVOKE  LoadCursor,esi,IDC_ARROW
        mov     wc.hCursor,eax
        INVOKE  LoadIcon,esi,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hbrBackground,COLOR_SCROLLBAR+1
        mov     wc.lpszMenuName,edi
        mov     wc.lpszClassName,offset WndClass
        mov     wc.hIconSm,eax
        INVOKE  RegisterClassEx,offset wc

;--------------------------

;dimension/position

        INVOKE  GetSystemMetrics,SM_CXSCREEN
        push    eax
        INVOKE  GetSystemMetrics,SM_CYSCREEN
        mov     ebp,192
        mov     edx,256
        pop     ecx
        sub     eax,ebp
        sub     ecx,edx
        shr     eax,1
        shr     ecx,1

;--------------------------

;create window

        INVOKE  CreateWindowEx,edi,offset WndClass,offset AppName,
                WS_OVERLAPPEDWINDOW,ecx,eax,edx,ebp,edi,ebx,esi,edi
        mov     hWin,eax
        push    eax                            ;UpdateWindow:hWnd
        INVOKE  ShowWindow,eax,SW_SHOWNORMAL
        CALL    UpdateWindow

;--------------------------

;message loop

        mov     esi,offset msg
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,esi
        INVOKE  DispatchMessage,esi

mLoop1: INVOKE  GetMessage,esi,edi,edi,edi
        neg     eax
        shr     eax,1
        jnz     mLoop0

;--------------------------

;exit

        INVOKE  ExitProcess,[esi].MSG.wParam

_main   ENDP

;*************************************************************************************************

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
        cmp     ecx,WM_COMMAND
        jz      WndPr1

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

WndPr0: leave
        JMP     DefWindowProc

WndPr1: cmp     wParam,IDM_FILE_SAVEAS
        jnz     WndPr0

;--------------------------

;IDM_FILE_SAVEAS

        mov     edx,offset FileName
        xor     eax,eax
        push    edx

        mov     ofn.lStructSize,76                      ;sizeof OPENFILENAME (old style)
        push    hWnd
        pop     ofn.hwndOwner
        push    hInstance
        pop     ofn.hInstance
        mov     ofn.lpstrFilter,offset FileTypeStrs
        mov     ofn.lpstrCustomFilter,eax
        mov     ofn.nMaxCustFilter,eax
        mov     ofn.nFilterIndex,1
        mov     ofn.lpstrFile,edx
        mov     ofn.nMaxFile,sizeof FileName
        mov     ofn.lpstrFileTitle,eax
        mov     ofn.nMaxFileTitle,eax
        mov     ofn.lpstrInitialDir,eax
        mov     ofn.lpstrTitle,offset szSaveAs
        mov     ofn.Flags,OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT ;or OFN_EXTENSIONDIFFERENT
        mov dword ptr ofn.nFileOffset,eax
        mov     ofn.lpstrDefExt,offset FileExt
        mov     ofn.lCustData,eax
        mov     ofn.lpfnHook,eax
        mov     ofn.lpTemplateName,eax

        mov     [edx],eax
        INVOKE  GetSaveFileName,offset ofn
        or      eax,eax
        pop     edx
        jz      WndPrY

        cmp byte ptr [edx],0
        jz      WndPrY

        INVOKE  MessageBox,hWnd,offset FileName,offset szSaveAs,MB_ICONQUESTION

;--------------------------

WndPrY: xor     eax,eax
        ret

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPrY

WndProc ENDP

;#################################################################################################

        END     _main

